#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#include <string.h>

#include "can.h"
#include "compat.h"


char testmsg0[]={"msg0000!"};
char testmsg1[]={"msg1111!"};
char testmsg2[]={"msg2222!"};
char testmsg3[]={"msg3333!"};
char testmsg4[]={"msg4444!"};
char testmsg5[]={"msg5555!"};
char start[8];
int  isaVect[]={0,3,4,5,7,9,10,11,12,14,15};


void main
    (
    int           argc,
    char*         argv[]
    )
    {
    int           l,l1;
    int           busy=1;
    unsigned char data[8];
    int           length;
    int           id;
    int           ok;
    int           msgStatus;
    int           status;
    int           net;
    param_struct  param;

    int myIrq  = 0;
    int myAddr = 0x1e0;

    printf("Starting test with compatible library...\n");

    if (argc > 1)
	{
	myIrq=atoi(argv[1]);
	ok = 0;
	for (l=0;l<11;l++)
	    {
	    if (myIrq == isaVect[l])
		ok=1;
	    }
	if (ok == 0)
	    {
	    printf("Illegal IRQ used...\n");
	    exit(1);
	    }
	printf("Used Irq %d\n",myIrq);
	}

    if (argc > 2)
	{
	myAddr=atoi(argv[3]);
	printf("Used IO Base Addr %04x\n",myAddr);
	}

    status = CAN_initialize_board(myAddr);
    if(myIrq == 0)
	{
	status = CAN_reset_board();
	}
    else
	{
	status = canEnableIrq(myIrq);
	sleep(5);
	}
    status = canInit(0,2);
    printf("Enabling Id's...\n");
    CAN_set_acceptance(0,0);
    // Make canOpem Modules happy
    start[0]=1;start[1]=0;
    printf("Sending start message...\n");
    status = canWrite(0,0,2,&start[0]);
    do
	{
	msgStatus = CAN_read(&param);
	if(msgStatus == 1)
	    {
	    printf("Can Rx Frame %04X %2X ",param.Ident,param.DataLength);
	    if (param.DataLength != 0)
		{
		for (l=0;l<param.DataLength;l++)
		    printf("%02X ",(unsigned char) (param.RCV_data[l]));
		}
		printf("\n");
	    if (id == 2)
		{
		status = canWrite(0,id+1,8,&testmsg0[0]);
		status = canWrite(0,id+2,8,&testmsg1[0]);
		status = canWrite(0,id+3,8,&testmsg2[0]);
		status = canWrite(0,id+4,8,&testmsg3[0]);
		status = canWrite(0,id+5,8,&testmsg4[0]);
		status = canWrite(0,id+6,8,&testmsg5[0]);
		testmsg0[7]++;if(testmsg0[7] > 'z') testmsg0[7]='!';
		testmsg1[7]++;if(testmsg1[7] > 'z') testmsg1[7]='!';
		testmsg2[7]++;if(testmsg2[7] > 'z') testmsg2[7]='!';
		testmsg3[7]++;if(testmsg3[7] > 'z') testmsg3[7]='!';
		testmsg4[7]++;if(testmsg4[7] > 'z') testmsg4[7]='!';
		testmsg5[7]++;if(testmsg5[7] > 'z') testmsg5[7]='!';
		}
	    }
	if(msgStatus == 2)
	    {
	    printf("Can RTRFrame %04X %2X\n",param.Ident,param.DataLength);
	    }
	if(msgStatus == 3)
	    {
	    printf("Can Tx done  %04X %2X\n",param.Ident,param.DataLength);
	    }
	if(msgStatus == 5)
	    {
	    printf("Can Error\n");
	    }
	if(msgStatus == 6)
	    {
	    printf("Can Tx Tout  %04X %2X\n",param.Ident,param.DataLength);
	    }
	if (kbhit())
	    {
	    status = getch();
	    busy=0;
	    }
	}
    while (busy);
    if (myIrq != 0)
	status = canDisableIrq();
    exit(0);
    }
