/*-- Headerdateien --*/
#include <windows.h>
#include <commdlg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <time.h>
#include "canspy.h"
#define EXPORT FAR PASCAL
#define DIST FAR
#include "can.h"
#include "resrc1.h"


#define USE_LISTBOX

#define swap(data) (((data << 8) & 0xFF00) | ((data >> 8) & 0x00FF))

/*-- Prototypen --*/
int      PASCAL WinMain(HANDLE, HANDLE, LPSTR, int);
LONG FAR PASCAL WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL            InitFirstInstance(HANDLE);
BOOL            InitNewInstance(HANDLE, int);
int             ProcessMessages(void);
/* function for the box to initialize the card */
int             InitBox(HWND, 
						LPSTR, 
						LPSTR, 
						LPSTR, 
						LPSTR, 
						LPSTR);
/* function for the box to configure the CAN-message */
int 			ConfigBox(HWND);

/* also for the initialization */
BOOL FAR PASCAL DlgInit(HWND hDlg, UINT msg,
								 WPARAM wParam, LPARAM lParam);

/* also for the configuration */
BOOL FAR PASCAL DlgConfig(HWND hDlg, UINT msg,
								 WPARAM wParam, LPARAM lParam);

/* readMessage reads the CAN-messages */
int readMessage(void);

/* doing jobs on menu-messages */
void MenuJob(HWND, WPARAM, LPARAM);
void FileJob(HWND hWnd);

/*-- Globale Variablen --*/
HWND hListBox;

HWND   hMainWindow;
HANDLE hMainInst;
LPSTR lpszMainTitle = "canSpy";
LPSTR lpszClassName = "exampleprogram";
int 	glNet; /*global Netnumber*/
int 	glBaud; /*global Baudrate*/
int 	glIoPort; /*Io-Port used by CAN-Card*/
int 	glIntr; /* global Interrupt used by the CAN-Card*/
char 	glSzNet[8]; /*String for Net*/
char 	glSzBaud[16]; /*String for Baudrate*/
char 	glSzIo[16]; /*String for IO-Port*/
char 	glSzIntr[8]; /*String for Interrupt*/
BOOL 	glShowMsgs; /*global BOOL for displaying messages*/
BOOL 	glInitialized; /*global BOOL showing if Card is initialized*/

int 	glId; /*global for ID used with message to be sent*/
int 	glRTR; /* global RTR*/
int 	glLen; /*global length of CAN-message*/
char	glData[8]; /*global CAN-message-data*/

/* structure for initialization-message-box */
struct InputDlgInfo
{
	LPSTR lpszText;
	LPSTR lpszKopf;
	LPSTR lpszNet;
	LPSTR lpszBaud;
	LPSTR lpszIo;
	LPSTR lpszIntr;
};


/* global variable for Init-Dialog-Box */
struct InputDlgInfo IDIVar;

/*-- Function: WinMain --*/
int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance,
                   LPSTR lpszCmdLine, int nCmdShow)
{
  /* initialize first instance */
  if(!hPrevInstance)
    if(!InitFirstInstance(hInstance)) return FALSE;

  /* inititalize actual instance */
  InitNewInstance(hInstance, nCmdShow);

  /* initialize glShowMessages */
  glShowMsgs = FALSE;

  /* initialize glInitialized */
  glInitialized = FALSE;

  /* prepare message queue */
  return ProcessMessages();
}

/* Function: InitFirstInstance --*/
BOOL InitFirstInstance(HANDLE hInstance)
{
  WNDCLASS wc;

  wc.style         = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc   = WndProc;
  wc.cbClsExtra    =
  wc.cbWndExtra    = 0;
  wc.hInstance     = hInstance;
  wc.hIcon         = 0;
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockObject(WHITE_BRUSH);
  wc.lpszMenuName  = "Hauptmenu";
  wc.lpszClassName = lpszClassName;

  return RegisterClass(&wc) ? TRUE : FALSE;
}

/* Function: InitNewInstance */
BOOL InitNewInstance(HANDLE hInstance, int nCmdShow)
{
  hMainInst = hInstance;

  hMainWindow = CreateWindow(
	  lpszClassName,
	  lpszMainTitle,
	  WS_OVERLAPPEDWINDOW,
	  CW_USEDEFAULT, CW_USEDEFAULT,
	  CW_USEDEFAULT, CW_USEDEFAULT,
	  NULL,
	  NULL,
	  hInstance,
	  NULL);

  if(!hMainWindow) return FALSE;

  ShowWindow(hMainWindow, nCmdShow);
  UpdateWindow(hMainWindow);

  return TRUE;
}

/*-- Function: ProcessMessages --*/
int ProcessMessages(void)
{
  MSG  msg;
  BOOL bResult;

  bResult = TRUE;
  while(TRUE)
  {
	bResult = PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
	if (bResult == TRUE)
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	if ((glShowMsgs == TRUE) && (glInitialized == TRUE))
	{
		/* after all jobs done on window messages: reading all CAN messages */
		bResult = readMessage();
	}
  }
  return msg.wParam;
}

/*-- window function: WndProc --*/
/* processing window messages from main window */
LONG FAR PASCAL WndProc(HWND hWnd, UINT msg,
								WPARAM wParam, LPARAM lParam)
{
	int 	i;
	LRESULT result;
	char 	strError[256];
  
  switch(msg)
  {
	case WM_CREATE:
		/*creating Listbox into client area of main window */
		hListBox = CreateWindow("LISTBOX", NULL,
			(WS_CHILD | WS_VISIBLE | LBS_STANDARD) & ~LBS_SORT,
			0, 0, 0, 0, hWnd, NULL,
			hMainInst, NULL);

		if (hListBox == NULL)
		{
			sprintf(&strError[0], "CreateWindow returned NULL");
			MessageBox(hWnd, &strError[0], "Error", MB_OK);
			PostQuitMessage(0);
			return (0);
		}
		glId = 2047;
		glRTR = 0;
		glLen = 8;
		for (i=0;i<8;i++)
		{
		 	glData[i] = (char) (i & 0xff);
		}
		glShowMsgs = FALSE;
		break;
	case WM_SIZE:
		/* resizing Listbox to size of client area */
		result = MoveWindow(hListBox,
			0, 0,
			LOWORD(lParam),
			HIWORD(lParam),
			TRUE);
		if (result == 0)
		{
			sprintf(&strError[0], "MoveWindow returned 0");
			MessageBox(hWnd, &strError[0], "Error", MB_OK);
			PostQuitMessage(0);
			return (0);
		}
		break;
	case WM_COMMAND:
		MenuJob(hWnd, wParam, lParam);
		break;
	 case WM_DESTROY :
		DestroyWindow(hListBox);
		PostQuitMessage(0);
		return 0;
  }
  return DefWindowProc(hWnd, msg, wParam, lParam);
}

/* processing menu messages */
void MenuJob(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	int 	result, i;
	char 	strError[256];
    CAN_MSG start0;
    char    start1[20];
    int     version  = 0;
		
		switch(wParam)
		{
/*
			case CM_FILEOPEN:
				FileJob(hWnd);
				break;
*/
			case CM_FILEEXIT:
				/* the user wants to end this program */
				/* if the card is initialized and the ID's are enabled: */
				if (glInitialized == TRUE)
				{
					for (i=0;i<0x800;i++)
					{
						/* disabling all ID's */
						result = canDisableId (glNet, i);
						if (result != 0)
						{
							break;
						}
					}
					/* disabling the interrupt */
					result = canDisableIrq();
					if (result != 0)
					{
						sprintf(&strError[0], "canDisableIrq returned: %x", result);
						MessageBox(hWnd, &strError[0], "Error", MB_OK);
					}
					glInitialized = FALSE;
				}
				DestroyWindow(hWnd);
				break;
			case CM_FILEINIT:
				/* opening the dialog box for initialize the CAN Card */
	  			if (InitBox(hWnd, 
	  				"Initialize", 
	  				glSzNet, 
	  				glSzBaud, 
	  				glSzIo, 
	  				glSzIntr) == IDOK)
				{
					sprintf(&strError[0], "setting up the Card. This will stop the System for 1-2 sec. !");
					MessageBox(hWnd, &strError[0], "Error", MB_OK);
					result = canHwInit(glIoPort); 	/* initialize Hardware on I/O Port address 0x1e0 */
					if (result != 0)
					{
						sprintf(&strError[0], "canHwInit returned: %x", result);
						MessageBox(hWnd, &strError[0], "Error", MB_OK);
					}

					/* enabling the interrupt */
					result = canEnableIrq(glIntr);
					if (result != 0)
					{
						sprintf(&strError[0], "canEnableIrq returned: %x", result);
						MessageBox(hWnd, &strError[0], "Error", MB_OK);
					}
					sprintf(&strError[0], "The System is resetted. Now waiting for the Board Identification Message !");
					MessageBox(hWnd, &strError[0], "Error", MB_OK);
					/*waiting for the Board Message*/
    				while (canMsg(&start0) == -1);
    				if (start0.cmmd == CAN_HM_BOARDID)
					{
						memset(&start1[0],0,sizeof(start1));
						memcpy(&start1[0],(void*)&start0.len,16);
						version = swap(start0.id);
						sprintf(&strError[0], "Board Message:%s Version %04X\n",start1,version);
						MessageBox(hWnd, &strError[0], "Error", MB_OK);
					}
    				else
    				{
        				sprintf(&strError[0], "No board Message Error, exit ...\n");
						MessageBox(hWnd, &strError[0], "Error", MB_OK);
        				result = canDisableIrq();
        				return;
    				}
					/*initialize the CAN Card*/
					result = canInit(glNet, glBaud);		/* init net 0 on baudrate 500 kbit/s */	
					if (result != 0)
					{
						sprintf(&strError[0], "canInit returned: %x", result);
						MessageBox(hWnd, &strError[0], "Error", MB_OK);
					}

					for (i=0;i<0x800;i++)
					{
						/*enabling the ID's*/
						result = canEnableId (glNet, i);
						if (result != 0)
						{
							break;
						}
					}
					if (result != 0)
					{
						sprintf(&strError[0], "canEnableId returned: %x for i = %x", result, i);
						MessageBox(hWnd, &strError[0], "Error", MB_OK);
					}
					glInitialized = TRUE;
				}
				break;
			case CM_MSGCONFIG:
	  			/*opening the Configuration Dialog*/
	  			if (ConfigBox(hWnd) == IDOK)
				{
				}
				break;
			case CM_MSGSEND:
				/*sending the message as configured*/
				result = canWrite ((int)glNet,(int)glId,(int)glLen,(unsigned char DIST *)&glData[0]);
				if (result != 0)
				{
					sprintf(&strError[0], "canWrite returned: %x", result);
					MessageBox(hWnd, &strError[0], "Error", MB_OK);
				}
				break;
			case CM_MSGSTART:
				/*start displaying messages and events*/
				glShowMsgs = TRUE;
				break;
			case CM_MSGSTOP:
				/*stop displaying messages and events*/
				glShowMsgs = FALSE;
				break;
		}

}


/* InitBox : Function for the initialization dialog for the CAN-Card */
int InitBox(HWND hWnd, 
			LPSTR lpszKopf, 
			LPSTR lpszNet, 
			LPSTR lpszBaud, 
			LPSTR lpszIo, 
			LPSTR lpszIntr 
			)
{
  FARPROC lpfnDlg;
  int     iReturn;

  IDIVar.lpszKopf = lpszKopf;
  IDIVar.lpszNet = lpszNet;
  IDIVar.lpszBaud = lpszBaud;
  IDIVar.lpszIo = lpszIo;
  IDIVar.lpszIntr = lpszIntr;


  lpfnDlg = MakeProcInstance(DlgInit, hMainInst);
  iReturn = DialogBox(hMainInst, "INITDIALOG",
							 hWnd, lpfnDlg);
  
  FreeProcInstance(lpfnDlg);

  return iReturn;
}


/* ConfigBox : Function for dialog box for the configuration of the CAN message */
int ConfigBox(HWND hWnd)
{
  FARPROC lpfnCfgDlg;
  int     iReturn;


  lpfnCfgDlg = MakeProcInstance(DlgConfig, hMainInst);
  iReturn = DialogBox(hMainInst, "CONFIGDIALOG",
							 hWnd, lpfnCfgDlg);
	if (iReturn < 0)
		MessageBox(hWnd, "Dialogbox nicht erzeugt", "Fehler", MB_OK);
	  
  FreeProcInstance(lpfnCfgDlg);

  return iReturn;
}


/* DlgConfig : Function for configuration of the CAN message */
BOOL FAR PASCAL DlgConfig(HWND hDlg, UINT msg,
								 WPARAM wParam, LPARAM lParam)
{
	char 	strBuffer[256];
	LRESULT	result;	
	int 	i;
	int 	tmpInt;
	
  switch(msg)
  {
	case WM_INITDIALOG :
		SetWindowText(hDlg, "Configure Can Message");
		sprintf(&strBuffer[0], "%i\0", glId);
		result = SendDlgItemMessage(hDlg, IDC_EDTID, WM_SETTEXT, 0, (LONG) (LPSTR) &strBuffer[0]);
		sprintf(&strBuffer[0], "%i\0", glRTR);
		result = SendDlgItemMessage(hDlg, IDC_EDTRTR, WM_SETTEXT, 0, (LONG) (LPSTR) &strBuffer[0]);
		sprintf(&strBuffer[0], "%i\0", glLen);
		result = SendDlgItemMessage(hDlg, IDC_EDTLEN, WM_SETTEXT, 0, (LONG) (LPSTR) &strBuffer[0]);
		for (i=0;i<8;i++)
		{
			sprintf(&strBuffer[0], "%i\0", glData[i]);
			result = SendDlgItemMessage(hDlg, IDC_EDTDATA1 + i, WM_SETTEXT, 0, (LONG) (LPSTR) strBuffer);
		}

		return TRUE;
	case WM_COMMAND :
		switch(wParam)
		{
			case IDOK :
				result = SendDlgItemMessage(hDlg, IDC_EDTID, WM_GETTEXT, 256, (LONG) (LPSTR) strBuffer);
				glId = atoi (strBuffer);
				if ((glId < 0) || (glId > 2047))
				{
					MessageBox(hDlg, 
								"Invalid Identifier! Please change.", 
								"Error", 
								MB_OK);
					break;
					
				}
				result = SendDlgItemMessage(hDlg, IDC_EDTRTR, WM_GETTEXT, 256, (LONG) (LPSTR) strBuffer);
				glRTR = atoi (strBuffer);
				if ((glRTR < 0) || (glRTR > 1))
				{
					MessageBox(hDlg, 
								"Invalid value for RTR! Please change.", 
								"Error", 
								MB_OK);
					break;
					
				}
				result = SendDlgItemMessage(hDlg, IDC_EDTLEN, WM_GETTEXT, 256, (LONG) (LPSTR) strBuffer);
				glLen = atoi (strBuffer);
				if ((glLen < 0) || (glLen > 8))
				{
					MessageBox(hDlg, 
								"Invalid message length! Please change.", 
								"Error", 
								MB_OK);
					break;
					
				}
				for (i=0;i<8;i++)
				{
					result = SendDlgItemMessage(hDlg, IDC_EDTDATA1 + i, WM_GETTEXT, 256, (LONG) (LPSTR) strBuffer);
				  	sscanf(strBuffer, "%x", &tmpInt);
					if ((tmpInt < 0x0) || (tmpInt > 0xff))
					{
						MessageBox(hDlg, 
									"Invalid Data! Please change.", 
									"Error", 
									MB_OK);
						return TRUE;
						break;
					}
					glData[i] = (char) (tmpInt & 0xff);
				}
			case IDCANCEL :
		     	EndDialog(hDlg, wParam);
			  	return TRUE;
		}
  }
  return FALSE;
}

/* DlgInit : Function for processing messages from init dialog */
BOOL FAR PASCAL DlgInit(HWND hDlg, UINT msg,
								 WPARAM wParam, LPARAM lParam)
{
	char 	strBuffer[256];
	LRESULT	result;
	
  switch(msg)
  {
	case WM_INITDIALOG :
		if(IDIVar.lpszKopf)
			SetWindowText(hDlg, IDIVar.lpszKopf);

		sprintf(&strBuffer[0], "0\0");
		result = SendDlgItemMessage(hDlg, ID_NETEDIT, WM_SETTEXT, 0, (LONG) (LPSTR) strBuffer);
		sprintf(&strBuffer[0], "6\0");
		result = SendDlgItemMessage(hDlg, ID_BAUDEDIT, WM_SETTEXT, 0, (LONG) (LPSTR) strBuffer);
		sprintf(&strBuffer[0], "0x1e0\0");
		result = SendDlgItemMessage(hDlg, ID_IOEDIT, WM_SETTEXT, 0, (LONG) (LPSTR) strBuffer);
		sprintf(&strBuffer[0], "5\0");
		result = SendDlgItemMessage(hDlg, ID_INTREDIT, WM_SETTEXT, 0, (LONG) (LPSTR) strBuffer);


		return TRUE;
	case WM_COMMAND :
		switch(wParam)
		{
		  case IDOK :
		    GetDlgItemText(hDlg, ID_NETEDIT, 
		                   IDIVar.lpszNet, 8);
		    GetDlgItemText(hDlg, ID_BAUDEDIT, 
		                   IDIVar.lpszBaud, 8);
		    GetDlgItemText(hDlg, ID_IOEDIT, 
		                   IDIVar.lpszIo, 8);
		    GetDlgItemText(hDlg, ID_INTREDIT, 
		                   IDIVar.lpszIntr, 8);
		  	/* global glNet */
		  	glNet = atoi ((const char *)IDIVar.lpszNet);
		  	/* if invalid Netnumber choosed */
		  	if ((glNet < 0) || (glNet > MAX_NET))
		  	{
				MessageBox(hDlg, 
				"Invalid Netnumber! Please change.", 
				"Error", 
				MB_OK);
				break;
		  	}
		  	/* global glBaud */
		  	glBaud = atoi ((const char *)IDIVar.lpszBaud);
		  	/* if invalid Baudrate choosed */
		  	if ((glBaud < 0) || (glBaud > MAX_BAUD))
		  	{
				MessageBox(hDlg, 
				"Invalid Baudrate table index! Please change.", 
				"Error", 
				MB_OK);
				break;
		  	}
		  	/* global glIoPort */
		  	sscanf((const char *)IDIVar.lpszIo, "0x%x", &glIoPort);
		  	/* if invalid IoPort choosed */
		  	if ((glIoPort < MIN_IOPORT) || (glIoPort > MAX_IOPORT))
		  	{
				MessageBox(hDlg, 
				"Invalid Io Port Address! Please change.", 
				"Error", 
				MB_OK);
				break;
		  	}
		  	/* global glIntr */
		  	glIntr = atoi ((const char *) IDIVar.lpszIntr);
		  	/* if invalid Interrupt choosed */
		  	if ((glIntr < 0) || (glIntr > MAX_INTR))
		  	{
				MessageBox(hDlg, 
				"Invalid Io Port Address! Please change.", 
				"Error", 
				MB_OK);
				break;
		  	}
				
		  case IDCANCEL :
		     EndDialog(hDlg, wParam);
			  return TRUE;
		}
  }
  return FALSE;
}


int readMessage(void)
{
	int net;
	int id;
	int length;
	unsigned char data[8];
    int result;
    int rtr;
	LRESULT ItemCount;
    char strTemp[128];
	           
	result = 0;
	while (result != -1)
	{
		memset (&data[0], 0, 8);
		/* reading a can message */
		result = canRead(&net, &id, &length, &data[0]);	           
		/* if a valid CAN message or event received: */
		if (result >= 0)
		{
			switch (result) 
			{
			/* if normal CAN message: */
			case CAN_HM_BCAN:
				rtr = ((length & 0x10) >> 4);
				switch (length)
				{   	
					case 0:
						sprintf(&strTemp[0], "ID: %4.4d  RTR: %1.1d  Len:%1.1d", 
							id, rtr, length);
						break;
					case 1:
						sprintf(&strTemp[0], "ID: %4.4d  RTR: %1.1d  Len: %1.1d  Data: %2.2x", 
							id, rtr, length, data[0]);
						break;
					case 2:
						sprintf(&strTemp[0], "ID: %4.4d  RTR: %1.1d  Len: %1.1d  Data: %2.2x %2.2x", 
							id, rtr, length, data[0], data[1]);
						break;
					case 3: 	
						sprintf(&strTemp[0], "ID: %4.4d  RTR: %1.1d  Len: %1.1d  Data: %2.2x %2.2x %2.2x", 
							id, rtr, length, 
							data[0], 
							data[1], 
							data[2]
							);
						break;
					case 4:
						sprintf(&strTemp[0], "ID: %4.4d  RTR: %1.1d  Len: %1.1d  Data: %2.2x %2.2x %2.2x %2.2x", 
							      						id, rtr, length, 
							data[0], 
							data[1], 
							data[2], 
							data[3]
							);
						break;
					case 5:
						sprintf(&strTemp[0], 
								"ID: %4.4d  RTR: %1.1d  Len: %1.1d  Data: %2.2x %2.2x %2.2x %2.2x %2.2x", 
							id, rtr, length, 
							data[0], 
							data[1], 
							data[2], 
							data[3], 
							data[4]
							);
						break;
					case 6: 	
						sprintf(&strTemp[0], 
								"ID: %4.4d  RTR: %1.1d  Len: %1.1d  Data: %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x", 
							id, rtr, length, 
							data[0], 
							data[1], 
							data[2], 
							data[3],
							data[4],
							data[5]
							);
						break;
					case 7:
						sprintf(&strTemp[0], 
								"ID: %4.4d  RTR: %1.1d  Len: %1.1d  Data: %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x", 
							id, rtr, length, 
							data[0], 
							data[1], 
							data[2],
							data[3],
							data[4],
							data[5],
							data[6]
							);
						break;
					case 8:
						sprintf(&strTemp[0], 
								"ID: %4.4d  RTR: %1.1d  Len: %1.1d  Data: %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x", 
							id, rtr, length, 
							data[0], 
							data[1], 
							data[2],
							data[3],
							data[4],
							data[5],
							data[6],
							data[7]
							);
						break;
				}
				SendMessage (hListBox, LB_ADDSTRING, 0, (LONG) (LPSTR) &strTemp[0]);
				ItemCount = SendMessage (hListBox, LB_GETCOUNT, 0, 0);
				ItemCount--;
				SendMessage (hListBox, LB_SETTOPINDEX, (WPARAM) ItemCount, (LPARAM) 0);
				break;
			/* if TX DONE: (sent a message) */
			case CAN_HM_TXDONE:
				rtr = ((length & 0x10) >> 4);
				sprintf(&strTemp[0], "sent: ID: %4.4d  RTR: %1.1d  Len: %1.1d", 
						id, rtr, length);
				SendMessage (hListBox, LB_ADDSTRING, 0, (LONG) (LPSTR) &strTemp[0]);
				ItemCount = SendMessage (hListBox, LB_GETCOUNT, 0, 0);
				ItemCount--;
				SendMessage (hListBox, LB_SETTOPINDEX, (WPARAM) ItemCount, (LPARAM) 0);
				break;
			/* if no message or event was received: */
			case -1:
				break;
			/* else: display every event received */
			default: 
				sprintf(&strTemp[0], 
					"Event: %3.3d ID: %4.4d  RTR: %1.1d  Len: %1.1d  Data: %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x", 
						result, id, rtr, length, data[0], 
												 data[1], 
												 data[2], 
												 data[3], 
												 data[4], 
												 data[5], 
												 data[6], 
												 data[7]);
												 
				SendMessage (hListBox, LB_ADDSTRING, 0, (LONG) (LPSTR) &strTemp[0]);
				ItemCount = SendMessage (hListBox, LB_GETCOUNT, 0, 0);
				ItemCount--;
				SendMessage (hListBox, LB_SETTOPINDEX, (WPARAM) ItemCount, (LPARAM) 0);
				break;
     	
			}
		}
    }
	return (0);
}
